//
// OpenHouse.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct OpenHouse: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var appointmentRequiredYN: Bool?
    public var openHouseDate: Date?
    public var listingKeyNumeric: Double?
    public var openHouseKeyNumeric: Double?
    public var showingAgentKeyNumeric: Double?
    public var listingId: String?
    public var listingKey: String?
    public var openHouseId: String?
    public var openHouseKey: String?
    public var openHouseRemarks: String?
    public var originatingSystemID: Double?
    public var originatingSystemKey: String?
    public var originatingSystemName: String?
    public var refreshments: String?
    public var showingAgentFirstName: String?
    public var showingAgentKey: String?
    public var showingAgentLastName: String?
    public var showingAgentMlsID: String?
    public var sourceSystemID: Double?
    public var sourceSystemKey: String?
    public var sourceSystemName: String?
    public var openHouseAttendedBy: String?
    public var openHouseStatus: String?
    public var openHouseType: String?
    public var modificationTimestamp: Date?
    public var openHouseEndTime: Date?
    public var openHouseStartTime: Date?
    public var originalEntryTimestamp: Date?
    public var showingAgent: Member?
    public var originatingSystem: OUID?
    public var sourceSystem: OUID?
    public var property: Property?

    public init(id: Int? = nil, appointmentRequiredYN: Bool? = nil, openHouseDate: Date? = nil, listingKeyNumeric: Double? = nil, openHouseKeyNumeric: Double? = nil, showingAgentKeyNumeric: Double? = nil, listingId: String? = nil, listingKey: String? = nil, openHouseId: String? = nil, openHouseKey: String? = nil, openHouseRemarks: String? = nil, originatingSystemID: Double? = nil, originatingSystemKey: String? = nil, originatingSystemName: String? = nil, refreshments: String? = nil, showingAgentFirstName: String? = nil, showingAgentKey: String? = nil, showingAgentLastName: String? = nil, showingAgentMlsID: String? = nil, sourceSystemID: Double? = nil, sourceSystemKey: String? = nil, sourceSystemName: String? = nil, openHouseAttendedBy: String? = nil, openHouseStatus: String? = nil, openHouseType: String? = nil, modificationTimestamp: Date? = nil, openHouseEndTime: Date? = nil, openHouseStartTime: Date? = nil, originalEntryTimestamp: Date? = nil, showingAgent: Member? = nil, originatingSystem: OUID? = nil, sourceSystem: OUID? = nil, property: Property? = nil) {
        self.id = id
        self.appointmentRequiredYN = appointmentRequiredYN
        self.openHouseDate = openHouseDate
        self.listingKeyNumeric = listingKeyNumeric
        self.openHouseKeyNumeric = openHouseKeyNumeric
        self.showingAgentKeyNumeric = showingAgentKeyNumeric
        self.listingId = listingId
        self.listingKey = listingKey
        self.openHouseId = openHouseId
        self.openHouseKey = openHouseKey
        self.openHouseRemarks = openHouseRemarks
        self.originatingSystemID = originatingSystemID
        self.originatingSystemKey = originatingSystemKey
        self.originatingSystemName = originatingSystemName
        self.refreshments = refreshments
        self.showingAgentFirstName = showingAgentFirstName
        self.showingAgentKey = showingAgentKey
        self.showingAgentLastName = showingAgentLastName
        self.showingAgentMlsID = showingAgentMlsID
        self.sourceSystemID = sourceSystemID
        self.sourceSystemKey = sourceSystemKey
        self.sourceSystemName = sourceSystemName
        self.openHouseAttendedBy = openHouseAttendedBy
        self.openHouseStatus = openHouseStatus
        self.openHouseType = openHouseType
        self.modificationTimestamp = modificationTimestamp
        self.openHouseEndTime = openHouseEndTime
        self.openHouseStartTime = openHouseStartTime
        self.originalEntryTimestamp = originalEntryTimestamp
        self.showingAgent = showingAgent
        self.originatingSystem = originatingSystem
        self.sourceSystem = sourceSystem
        self.property = property
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case appointmentRequiredYN = "AppointmentRequiredYN"
        case openHouseDate = "OpenHouseDate"
        case listingKeyNumeric = "ListingKeyNumeric"
        case openHouseKeyNumeric = "OpenHouseKeyNumeric"
        case showingAgentKeyNumeric = "ShowingAgentKeyNumeric"
        case listingId = "ListingId"
        case listingKey = "ListingKey"
        case openHouseId = "OpenHouseId"
        case openHouseKey = "OpenHouseKey"
        case openHouseRemarks = "OpenHouseRemarks"
        case originatingSystemID = "OriginatingSystemID"
        case originatingSystemKey = "OriginatingSystemKey"
        case originatingSystemName = "OriginatingSystemName"
        case refreshments = "Refreshments"
        case showingAgentFirstName = "ShowingAgentFirstName"
        case showingAgentKey = "ShowingAgentKey"
        case showingAgentLastName = "ShowingAgentLastName"
        case showingAgentMlsID = "ShowingAgentMlsID"
        case sourceSystemID = "SourceSystemID"
        case sourceSystemKey = "SourceSystemKey"
        case sourceSystemName = "SourceSystemName"
        case openHouseAttendedBy = "OpenHouseAttendedBy"
        case openHouseStatus = "OpenHouseStatus"
        case openHouseType = "OpenHouseType"
        case modificationTimestamp = "ModificationTimestamp"
        case openHouseEndTime = "OpenHouseEndTime"
        case openHouseStartTime = "OpenHouseStartTime"
        case originalEntryTimestamp = "OriginalEntryTimestamp"
        case showingAgent = "ShowingAgent"
        case originatingSystem = "OriginatingSystem"
        case sourceSystem = "SourceSystem"
        case property = "Property"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(appointmentRequiredYN, forKey: .appointmentRequiredYN)
        try container.encodeIfPresent(openHouseDate, forKey: .openHouseDate)
        try container.encodeIfPresent(listingKeyNumeric, forKey: .listingKeyNumeric)
        try container.encodeIfPresent(openHouseKeyNumeric, forKey: .openHouseKeyNumeric)
        try container.encodeIfPresent(showingAgentKeyNumeric, forKey: .showingAgentKeyNumeric)
        try container.encodeIfPresent(listingId, forKey: .listingId)
        try container.encodeIfPresent(listingKey, forKey: .listingKey)
        try container.encodeIfPresent(openHouseId, forKey: .openHouseId)
        try container.encodeIfPresent(openHouseKey, forKey: .openHouseKey)
        try container.encodeIfPresent(openHouseRemarks, forKey: .openHouseRemarks)
        try container.encodeIfPresent(originatingSystemID, forKey: .originatingSystemID)
        try container.encodeIfPresent(originatingSystemKey, forKey: .originatingSystemKey)
        try container.encodeIfPresent(originatingSystemName, forKey: .originatingSystemName)
        try container.encodeIfPresent(refreshments, forKey: .refreshments)
        try container.encodeIfPresent(showingAgentFirstName, forKey: .showingAgentFirstName)
        try container.encodeIfPresent(showingAgentKey, forKey: .showingAgentKey)
        try container.encodeIfPresent(showingAgentLastName, forKey: .showingAgentLastName)
        try container.encodeIfPresent(showingAgentMlsID, forKey: .showingAgentMlsID)
        try container.encodeIfPresent(sourceSystemID, forKey: .sourceSystemID)
        try container.encodeIfPresent(sourceSystemKey, forKey: .sourceSystemKey)
        try container.encodeIfPresent(sourceSystemName, forKey: .sourceSystemName)
        try container.encodeIfPresent(openHouseAttendedBy, forKey: .openHouseAttendedBy)
        try container.encodeIfPresent(openHouseStatus, forKey: .openHouseStatus)
        try container.encodeIfPresent(openHouseType, forKey: .openHouseType)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(openHouseEndTime, forKey: .openHouseEndTime)
        try container.encodeIfPresent(openHouseStartTime, forKey: .openHouseStartTime)
        try container.encodeIfPresent(originalEntryTimestamp, forKey: .originalEntryTimestamp)
        try container.encodeIfPresent(showingAgent, forKey: .showingAgent)
        try container.encodeIfPresent(originatingSystem, forKey: .originatingSystem)
        try container.encodeIfPresent(sourceSystem, forKey: .sourceSystem)
        try container.encodeIfPresent(property, forKey: .property)
    }
}

